﻿-- Addon:	ChiBar: option panel
-- Author:	Rakhan(EU-Azshara)

if select(2, UnitClass("player")) ~= "MONK" then
    return
end


------------------------------------------
--		OptionsPanel					--
------------------------------------------

function ChiBar:createOptionsUI()
	ChiBar.opanel = CreateFrame("Frame", "ChiBarOptionsPanel", UIParent)
	ChiBar.opanel.name = "ChiBar";
	InterfaceOptions_AddCategory(ChiBar.opanel);

	-- Title
	ChiBar.Widgets = {}
	ChiBar.Widgets.title = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.title:SetPoint("TOPLEFT", 16, -16)
	ChiBar.Widgets.title:SetText(ChiBar.VERSIONTEXT_OP)
	
	-- MainSettingTitle
	ChiBar.Widgets.mainsettTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.mainsettTitle:SetPoint("TOPLEFT", 16, -70)
	ChiBar.Widgets.mainsettTitle:SetText(ChiBarLocalization.OP_MAINTITLE)
	
	-- EnableCheckBox
	ChiBar.Widgets.enableBox = CreateFrame("CheckButton", "EnableCheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.enableBox:SetPoint("TOPLEFT", ChiBar.Widgets.mainsettTitle, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.enableBox:SetChecked(ChiBarDB.enable)
	ChiBar.Widgets.enableBox:SetScript("OnClick", ChiBar.enable)
	ChiBar.Widgets.enableText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.enableText:SetPoint("LEFT", ChiBar.Widgets.enableBox, "RIGHT", 10, 1)
	ChiBar.Widgets.enableText:SetText(ChiBarLocalization.OP_ENABLE)
	
	-- AutohideCheckBox
	ChiBar.Widgets.autohideBox = CreateFrame("CheckButton", "EnableCheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.autohideBox:SetPoint("TOPLEFT", ChiBar.Widgets.enableBox, "BOTTOMLEFT", 0, -1)
	ChiBar.Widgets.autohideBox:SetChecked(ChiBarDB.autohide)
	ChiBar.Widgets.autohideBox:SetScript("OnClick", ChiBar.autohide)
	ChiBar.Widgets.autohideText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.autohideText:SetPoint("LEFT", ChiBar.Widgets.autohideBox, "RIGHT", 10, 1)
	ChiBar.Widgets.autohideText:SetText(ChiBarLocalization.OP_AUTOHIDE)

	-- ScaleTitle
	ChiBar.Widgets.scaleTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.scaleTitle:SetPoint("TOPLEFT", ChiBar.Widgets.autohideBox, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.scaleTitle:SetText(ChiBarLocalization.OP_SCALETITLE)

	-- ScaleSlider
	ChiBar.Widgets.scaleSlider = CreateFrame('Slider', 'ScaleSlider', ChiBar.opanel, 'OptionsSliderTemplate')
	ChiBar.Widgets.scaleSlider:SetPoint("TOPLEFT", ChiBar.Widgets.scaleTitle, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.scaleSlider:SetMinMaxValues(0.1, 2)
	ChiBar.Widgets.scaleSlider:SetValue(ChiBarDB.scale)
	getglobal(ChiBar.Widgets.scaleSlider:GetName() .. 'Low'):SetText('0.1')
	getglobal(ChiBar.Widgets.scaleSlider:GetName() .. 'High'):SetText('2')
	ChiBar.Widgets.scaleSlider:SetScript("OnValueChanged", ChiBar.scaleUI)
	
	-- CurrentScale
	ChiBar.Widgets.currScaleText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.currScaleText:SetPoint("LEFT", ChiBar.Widgets.scaleSlider, "RIGHT", 25, 0)
	ChiBar.Widgets.currScaleText:SetText(ChiBarDB.scale)
	
	-- OrientationTitle
	ChiBar.Widgets.orientationTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.orientationTitle:SetPoint("LEFT", ChiBar.Widgets.scaleTitle, "RIGHT", 125, 0)
	ChiBar.Widgets.orientationTitle:SetText(ChiBarLocalization.OP_GROW_TITLE)
	
	-- OrientationBox1
	ChiBar.Widgets.verticalBox = CreateFrame("CheckButton", "Orientation1CheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.verticalBox:SetPoint("TOPLEFT", ChiBar.Widgets.orientationTitle, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.verticalBox:SetChecked(ChiBarDB.grow1)
	ChiBar.Widgets.verticalBox:SetScript("OnClick", ChiBar.updateVertHor)
	ChiBar.Widgets.verticalText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.verticalText:SetPoint("LEFT", ChiBar.Widgets.verticalBox, "RIGHT", 10, 1)
	ChiBar.Widgets.verticalText:SetText(ChiBarLocalization.OP_GROW_VERTICAL)
	
	-- OrientationBox2
	ChiBar.Widgets.horizontalBox = CreateFrame("CheckButton", "Orientation2CheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.horizontalBox:SetPoint("TOPLEFT", ChiBar.Widgets.verticalBox, "BOTTOMLEFT", 0, -1)
	ChiBar.Widgets.horizontalBox:SetChecked(not ChiBarDB.grow1)
	ChiBar.Widgets.horizontalBox:SetScript("OnClick", ChiBar.updateVertHor)
	ChiBar.Widgets.horizontalText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.horizontalText:SetPoint("LEFT", ChiBar.Widgets.horizontalBox, "RIGHT", 10, 1)
	ChiBar.Widgets.horizontalText:SetText(ChiBarLocalization.OP_GROW_HORIZONTAL)
	
	-- OrientationBox3
	ChiBar.Widgets.leftbottomBox = CreateFrame("CheckButton", "Orientation2CheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.leftbottomBox:SetPoint("LEFT", ChiBar.Widgets.verticalText, "RIGHT", 50, 0)
	ChiBar.Widgets.leftbottomBox:SetChecked(ChiBarDB.grow1)
	ChiBar.Widgets.leftbottomBox:SetScript("OnClick", ChiBar.updateGrowthDirec)
	ChiBar.Widgets.leftbottomText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.leftbottomText:SetPoint("LEFT", ChiBar.Widgets.leftbottomBox, "RIGHT", 10, 1)
	if ChiBarDB.grow1 then ChiBar.Widgets.leftbottomText:SetText(ChiBarLocalization.OP_GROW_LEFT)
	else ChiBar.Widgets.leftbottomText:SetText(ChiBarLocalization.OP_GROW_BOTTOM) end
	
	-- OrientationBox4
	ChiBar.Widgets.righttopBox = CreateFrame("CheckButton", "Orientation2CheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.righttopBox:SetPoint("TOPLEFT", ChiBar.Widgets.leftbottomBox, "BOTTOMLEFT", 0, -1)
	ChiBar.Widgets.righttopBox:SetChecked(not ChiBarDB.grow1)
	ChiBar.Widgets.righttopBox:SetScript("OnClick", ChiBar.updateGrowthDirec)
	ChiBar.Widgets.righttopText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.righttopText:SetPoint("LEFT", ChiBar.Widgets.righttopBox, "RIGHT", 10, 1)
	if ChiBarDB.grow1 then ChiBar.Widgets.righttopText:SetText(ChiBarLocalization.OP_GROW_RIGHT)
	else ChiBar.Widgets.righttopText:SetText(ChiBarLocalization.OP_GROW_TOP) end
	
	--DropboxTitle
	ChiBar.Widgets.dropdownTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.dropdownTitle:SetPoint("TOPLEFT", ChiBar.Widgets.scaleSlider, "BOTTOMLEFT", 0, -50)
	ChiBar.Widgets.dropdownTitle:SetText(ChiBarLocalization.OP_DROPBOXTITLE)
	
	-- TextureDropDown
	ChiBar.Widgets.dropdownMenu = CreateFrame("Frame", "DropdownMenu", ChiBar.opanel, "UIDropDownMenuTemplate")
	ChiBar.Widgets.dropdownMenu:SetPoint("TOPLEFT", ChiBar.Widgets.dropdownTitle, "BOTTOMLEFT", -10, -10)
	ChiBar.Widgets.dropdownItems = ChiBar.TEXTURE_NAMES
	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(ChiBar.Widgets.dropdownMenu, self:GetID())
		ChiBarDB.savedTexture = self:GetID()
		ChiBar:changeTexture()
	end
	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		for k, v in pairs(ChiBar.Widgets.dropdownItems) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end
	UIDropDownMenu_Initialize(ChiBar.Widgets.dropdownMenu, initialize)
	UIDropDownMenu_SetWidth(ChiBar.Widgets.dropdownMenu, 120);
	UIDropDownMenu_SetButtonWidth(ChiBar.Widgets.dropdownMenu, 120)
	UIDropDownMenu_JustifyText(ChiBar.Widgets.dropdownMenu, "LEFT")
	UIDropDownMenu_SetSelectedID(ChiBar.Widgets.dropdownMenu, ChiBarDB.savedTexture)

	-- OpacityTitle
	ChiBar.Widgets.opacityTitle = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ChiBar.Widgets.opacityTitle:SetPoint("LEFT", ChiBar.Widgets.dropdownTitle, "RIGHT", 110, 0)
	ChiBar.Widgets.opacityTitle:SetText(ChiBarLocalization.OP_OPACITYTITLE)
	
	-- SeperateBox
	ChiBar.Widgets.seperateBox = CreateFrame("CheckButton", "SeperateCheckBox", ChiBar.opanel, "OptionsBaseCheckButtonTemplate")
	ChiBar.Widgets.seperateBox:SetPoint("TOPLEFT", ChiBar.Widgets.opacityTitle, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.seperateBox:SetChecked(ChiBarDB.seperate)
	ChiBar.Widgets.seperateBox:SetScript("OnClick", ChiBar.enableSeperateOpacity)
	ChiBar.Widgets.seperateText = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.seperateText:SetPoint("LEFT", ChiBar.Widgets.seperateBox, "RIGHT", 10, 1)
	ChiBar.Widgets.seperateText:SetText(ChiBarLocalization.OP_SEPERATE)
	
	-- OpacitySubTitle1
	ChiBar.Widgets.opacitySubTitle1 = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalMed3")
	ChiBar.Widgets.opacitySubTitle1:SetPoint("TOPLEFT", ChiBar.Widgets.seperateBox, "BOTTOMLEFT", 5, -10)
	if ChiBarDB.seperate then ChiBar.Widgets.opacitySubTitle1:SetText(ChiBarLocalization.OP_OPACITYSUBTITLE1_2)
	else ChiBar.Widgets.opacitySubTitle1:SetText(ChiBarLocalization.OP_OPACITYSUBTITLE1_1)end
	
	-- OpacitySlider1
	ChiBar.Widgets.opacitySlider1 = CreateFrame('Slider', 'OpacitySlider1', ChiBar.opanel, 'OptionsSliderTemplate')
	ChiBar.Widgets.opacitySlider1:SetPoint("TOPLEFT", ChiBar.Widgets.opacitySubTitle1, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.opacitySlider1:SetMinMaxValues(0, 1)
	ChiBar.Widgets.opacitySlider1:SetValue(ChiBarDB.alpha1)
	getglobal(ChiBar.Widgets.opacitySlider1:GetName() .. 'Low'):SetText('0')
	getglobal(ChiBar.Widgets.opacitySlider1:GetName() .. 'High'):SetText('1')
	ChiBar.Widgets.opacitySlider1:SetScript("OnValueChanged", ChiBar.collectAlpha1)
	
	-- CurrentOpacity1
	ChiBar.Widgets.currOpacityText1 = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.currOpacityText1:SetPoint("LEFT", ChiBar.Widgets.opacitySlider1, "RIGHT", 25, 0)
	ChiBar.Widgets.currOpacityText1:SetText(ChiBarDB.alpha1)
	
	-- OpacitySubTitle2
	ChiBar.Widgets.opacitySubTitle2 = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontNormalMed3")
	ChiBar.Widgets.opacitySubTitle2:SetPoint("TOPLEFT", ChiBar.Widgets.opacitySlider1, "BOTTOMLEFT", 0, -20)
	ChiBar.Widgets.opacitySubTitle2:SetText(ChiBarLocalization.OP_OPACITYSUBTITLE2)
	
	-- OpacitySlider2
	ChiBar.Widgets.opacitySlider2 = CreateFrame('Slider', 'OpacitySlider2', ChiBar.opanel, 'OptionsSliderTemplate')
	ChiBar.Widgets.opacitySlider2:SetPoint("TOPLEFT", ChiBar.Widgets.opacitySubTitle2, "BOTTOMLEFT", 0, -10)
	ChiBar.Widgets.opacitySlider2:SetMinMaxValues(0, 1)
	ChiBar.Widgets.opacitySlider2:SetValue(ChiBarDB.alpha2)
	getglobal(ChiBar.Widgets.opacitySlider2:GetName() .. 'Low'):SetText('0')
	getglobal(ChiBar.Widgets.opacitySlider2:GetName() .. 'High'):SetText('1')
	ChiBar.Widgets.opacitySlider2:SetScript("OnValueChanged", ChiBar.collectAlpha2)
	
	-- CurrentOpacity2
	ChiBar.Widgets.currOpacityText2 = ChiBar.opanel:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	ChiBar.Widgets.currOpacityText2:SetPoint("LEFT", ChiBar.Widgets.opacitySlider2, "RIGHT", 25, 0)
	ChiBar.Widgets.currOpacityText2:SetText(ChiBarDB.alpha2)
	
	if not ChiBarDB.seperate then
		ChiBar.Widgets.opacitySubTitle2:Hide()
		ChiBar.Widgets.opacitySlider2:Hide()
		ChiBar.Widgets.currOpacityText2:Hide()
	end
	
	-- ChangeColorButton
	ChiBar.Widgets.colorButton = CreateFrame("Button", "ColorButton", ChiBar.opanel, "GameMenuButtonTemplate")
	ChiBar.Widgets.colorButton:SetHeight(25)
	ChiBar.Widgets.colorButton:SetWidth(100)
	ChiBar.Widgets.colorButton:SetPoint("TOPLEFT", ChiBar.Widgets.dropdownMenu, "BOTTOMLEFT", 0, -15)
	ChiBar.Widgets.colorButton:SetText(ChiBarLocalization.OP_COLORBTN)
	ChiBar.Widgets.colorButton:SetScript("OnClick", ChiBar.openColorPicker)
	
	-- ResetColorButton
	ChiBar.Widgets.resetColorButton = CreateFrame("Button", "ResetColorButton", ChiBar.opanel, "GameMenuButtonTemplate")
	ChiBar.Widgets.resetColorButton:SetHeight(25)
	ChiBar.Widgets.resetColorButton:SetWidth(100)
	ChiBar.Widgets.resetColorButton:SetPoint("TOPLEFT", ChiBar.Widgets.colorButton, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.resetColorButton:SetText(ChiBarLocalization.OP_RESETCOLORBTN)
	ChiBar.Widgets.resetColorButton:SetScript("OnClick", ChiBar.resetColor)
	
	-- LockButton
	ChiBar.Widgets.lockButton = CreateFrame("Button", "LockButton", ChiBar.opanel, "GameMenuButtonTemplate")
	ChiBar.Widgets.lockButton:SetHeight(25)
	ChiBar.Widgets.lockButton:SetWidth(100)
	ChiBar.Widgets.lockButton:SetPoint("TOPLEFT", ChiBar.Widgets.resetColorButton, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.lockButton:SetText(ChiBarLocalization.OP_LOCKBTN1)
	ChiBar.Widgets.lockButton:SetScript("OnClick", ChiBar.unlockFrame)
	
	-- ResetButton
	ChiBar.Widgets.resetButton = CreateFrame("Button", "ResetButton", ChiBar.opanel, "GameMenuButtonTemplate")
	ChiBar.Widgets.resetButton:SetHeight(25)
	ChiBar.Widgets.resetButton:SetWidth(100)
	ChiBar.Widgets.resetButton:SetPoint("TOPLEFT", ChiBar.Widgets.lockButton, "BOTTOMLEFT", 0, -5)
	ChiBar.Widgets.resetButton:SetText(ChiBarLocalization.OP_RESET)
	ChiBar.Widgets.resetButton:SetScript("OnClick", ChiBar.confirmReset)
end


------------------------------------------
--		PopUpHandling					--
------------------------------------------

-- PopUpHandling for Unlocking
StaticPopupDialogs["CHIBAR_UNLOCKFRAME"] = {
  text = ChiBarLocalization.OP_UNLOCKTEXT,
  button1 = ChiBarLocalization.OP_LOCKBTN2,
  OnAccept = function()
      ChiBar:lockFrame()
	  InterfaceOptionsFrame_OpenToCategory(ChiBar.opanel)
  end,
  OnCancel = function()
      ChiBar:lockFrame()
	  InterfaceOptionsFrame_OpenToCategory(ChiBar.opanel)
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
}

-- PopUpHandling for Resetting
StaticPopupDialogs["CHIBAR_RESETFRAME"] = {
  text = ChiBarLocalization.OP_RESETTEXT,
  button1 = YES,
  button2 = NO,
  OnAccept = function()
      ChiBar:reset()
  end,
  OnCancel = function()
	  InterfaceOptionsFrame_OpenToCategory(ChiBar.opanel)
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
}

------------------------------------------
--		End of Script					--
------------------------------------------